<template>
  <div class="create-credential">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <div class="title">Update project</div>
          <div class="subtitle">Update {{ project.displayName }}</div>
          <div class="input">
            <label>Project name</label>
            <div class="input-wrapper">
              <input id="project-name" type="text" placeholder="Project" v-model="displayName" />
            </div>
          </div>
          <div class="input">
            <label>Slug</label>
            <div class="input-wrapper" @click="$refs.slug.focus()">
              <span>https://scepter.dev/</span
              ><input
                    id="project-slug"
                ref="slug"
                type="text"
                placeholder="project"
                v-model="name"
              />
            </div>
          </div>
          <div class="input">
            <label>Description</label>
            <div class="input-wrapper">
              <input
                      id="project-description"
                type="text"
                placeholder="This is a very important project"
                v-model="description"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <button class="button color-2 float-right" @click="createProjectClicked">
      Update Project
    </button>
    <br /><br />
  </div>
</template>

<script>
import { mapActions } from "vuex";

export default {
  props: {
    project: {
      required: true
    }
  },
  data() {
    return {
      displayName: "",
      name: "",
      description: ""
    };
  },
  methods: {
    ...mapActions("projectModule", ["updateProject"]),
    createProjectClicked() {
      const payload = {
        id: this.project.id,
        displayName: this.displayName,
        name: this.name,
        description: this.description
      };
      this.updateProject(payload).then(() => {
        this.$toasters["main"].success("Project updated!");
        this.$emit("close");
      });
    }
  },
  watch: {
    displayName: function(newVal) {
      this.name = "";
      for (let i = 0; i < newVal.length; i++) {
        const char = newVal.charAt(i);
        switch (char) {
          case " ":
            this.name += "-";
            break;
          default:
            this.name += char.toLowerCase();
            break;
        }
      }
    }
  },
  mounted() {
    this.displayName = this.project.displayName;
    this.name = this.project.name;
    this.description = this.project.description;
  }
};
</script>

<style lang="scss">
.create-credential {
  padding-top: 10px;
  padding-bottom: 10px;
}
</style>
